# autogenerated file by genClass version 2.0 - DO NOT EDIT !
# command line was:
#  ./genClass.py -f -c ./NetworkList.idl NetworkList.py NC
#
# This file loads all the implementation classes
# for global functions edit NC_functions.py instead

## Copyright (C) 2000,2001 Red Hat, Inc.
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#

import sys
import UserList
from Alchemist import *
import FileBlackBox

true = (1==1)
false = not true


from NC_functions import *


class Network:
	def __init__(self, list = None, parent = None):
		
		self.__parent = parent
		self.changed = false
		self.dead = 0
		self.doClear()

		self.setList(list)
		# initialize all variables with None
		self.rollback()
		
	#
	# @brief returns the parent of this object
	# @return the parent of this object
	#
	def getParent(self):
		return self.__parent

	def setParent(self, parent):
		self.__parent = parent

	def doClear(self):
		# UnlinkList
		self.NetName = None
		self.__NetName_bak = None
		self.NetMask = None
		self.__NetMask_bak = None
		self.NetBits = None
		self.__NetBits_bak = None

		pass
	
	def setList(self, list):
		self.__list = list
		if not list:
			return
		#SetList


	#
	# @brief deletes this object from our parent and unlinks from the alchemist
	#
	def unlink(self):
		if self.dead:
			return
		self.dead = 1
		if self.__parent and self.__parent.dead:
			return
		parent = self.__parent
		del self.__parent
		if self.__list:
			ret = self.__list.unlink()
			del self.__list
		self.doClear()
		if parent:
			parent.removeNetwork(self)
			
	def test(self):
		# TestList
		self.testNetName(self.NetName)
		self.testNetMask(self.NetMask)
		self.testNetBits(self.NetBits)

		pass

	def setChanged(self, val):
		self.changed = val
		if self.__parent and val:
			self.__parent.setChanged(val)
		
	def commit(self, changed=true):
		# CommitList
		self.commitNetName(changed)
		self.commitNetMask(changed)
		self.commitNetBits(changed)

	
	def rollback(self):
		# BackupList
		self.NetName = self.__NetName_bak
		self.NetMask = self.__NetMask_bak
		self.NetBits = self.__NetBits_bak

		return

	def copy(self):
		n = Network(None, None)
		n.apply(self)
		return n

	def apply(self, other):
		if not other:
			self.unlink()
			return
		# ApplyList
		self.setNetName(other.getNetName())
		self.setNetMask(other.getNetMask())
		self.setNetBits(other.getNetBits())

		pass

	def testNetName(self, value):
		return 0

	def getNetName(self):
		return self.NetName

	def delNetName(self):
		self.NetName = None
	
	def setNetName(self, value):
		self.NetName = value

	def commitNetName(self, changed=true):
		if self.__NetName_bak != self.NetName:
			self.setChanged(changed)			
		self.__NetName_bak = self.NetName

	def testNetMask(self, value):
		return 0

	def getNetMask(self):
		return self.NetMask

	def delNetMask(self):
		self.NetMask = None
	
	def setNetMask(self, value):
		self.NetMask = value

	def commitNetMask(self, changed=true):
		if self.__NetMask_bak != self.NetMask:
			self.setChanged(changed)			
		self.__NetMask_bak = self.NetMask

	def testNetBits(self, value):
		return 0

	def getNetBits(self):
		return self.NetBits

	def delNetBits(self):
		self.NetBits = None
	
	def setNetBits(self, value):
		self.NetBits = value

	def commitNetBits(self, changed=true):
		if self.__NetBits_bak != self.NetBits:
			self.setChanged(changed)			
		self.__NetBits_bak = self.NetBits


class NetworkList(UserList.UserList):
	def __init__(self, list = None, parent = None):
		UserList.UserList.__init__(self)
		self.__parent = parent
		self.changed = false
		self.dead = 0
		self.doClear()

		self.setList(list)
		# initialize all variables with None
		self.rollback()
		
	#
	# @brief returns the parent of this object
	# @return the parent of this object
	#
	def getParent(self):
		return self.__parent

	def setParent(self, parent):
		self.__parent = parent

	def doClear(self):
		# UnlinkList
		self.data = []
		self.data_bak = []

		pass
	
	def setList(self, list):
		self.__list = list
		if not list:
			return
		#SetList


	#
	# @brief deletes this object from our parent and unlinks from the alchemist
	#
	def unlink(self):
		if self.dead:
			return
		self.dead = 1
		if self.__parent and self.__parent.dead:
			return
		parent = self.__parent
		del self.__parent
		if self.__list:
			ret = self.__list.unlink()
			del self.__list
		self.doClear()
		if parent:
			parent.removeNetworkList(self)
			
	def test(self):
		# TestList
		for pos in xrange(len(self.data)):
			self.data[pos].test()

		pass

	def setChanged(self, val):
		self.changed = val
		if self.__parent and val:
			self.__parent.setChanged(val)
		
	def commit(self, changed=true):
		# CommitList
		if self.data_bak and not self.data: self.setChanged(changed)
		elif not self.data_bak and self.data: self.setChanged(changed)
		elif len(self.data_bak) != len(self.data): self.setChanged(changed)
		else:
			for i in xrange(0, len(self.data_bak)):
				if self.data_bak[i] != self.data[i]: self.setChanged(changed)
		self.data_bak = self.data[:]
		for child in self.data:
			child.commit(changed)

	
	def rollback(self):
		# BackupList
		self.data = self.data_bak[:]
		for child in self.data:
			child.rollback()

		return

	def copy(self):
		n = NetworkList(None, None)
		n.apply(self)
		return n

	def apply(self, other):
		if not other:
			self.unlink()
			return
		# ApplyList
		for pos in xrange(self.getNumNetwork() ):
			self.delNetwork(0)
		for pos in xrange(other.getNumNetwork() ):
			self.addNetwork()
			self.getNetwork(pos).apply(other.getNetwork(pos))

		pass

	def getNetwork(self, pos):
		return self.data[pos]

	def delNetwork(self, pos):
		self.data.pop(pos)
		return 0

	def getNumNetwork(self):
		return len(self.data)

	def moveNetwork(self, pos1, pos2):
		direct = 0
		if pos2 > pos1: direct = 1
		obj = self.data.pop(pos1)
		self.data.insert(obj, pos2 - direct)
		return 0

	def addNetwork(self):
		self.data.append(Network(None, self))
		return len(self.data)-1

	def removeNetwork(self, child):
		try: self.remove(child)
		except ValueError: pass

	def __setitem__(self, i, item):
		UserList.UserList.__setitem__(self, i, item)
		item.setParent(self)

	def append(self, item):
		UserList.UserList.append(self, item)
		item.setParent(self)
		
	def insert(self, i, item):
		UserList.UserList.insert(self, i, item)
		item.setParent(self)
		


if __name__ == '__main__':

	argc = len(sys.argv)

	if argc < 2:
		print "Usage: " + sys.argv[0] + " <input file>"
		sys.exit(10)

	boxpath = sys.argv[1]

	bbc = Context(name = 'FileBlackBox', serial = 1)
	broot = bbc.getDataRoot()
	list = broot.addChild(Data.ADM_TYPE_LIST, 'box_cfg')
	list.addChild(Data.ADM_TYPE_STRING, 'path').setValue(boxpath)
	list.addChild(Data.ADM_TYPE_STRING, 'box_type').setValue('FileBlackBox')
	list.addChild(Data.ADM_TYPE_BOOL, 'readable').setValue(1)
	list.addChild(Data.ADM_TYPE_BOOL, 'writable').setValue(0)
	bb = FileBlackBox.FileBlackBox(list)

	if bb.errNo():
		print 'Error creating FileBlackBox: ' + bb.strError()
		sys.exit(10)

	if bb.isReadable():
		con = bb.read() 
		if con == None:
			if bb.errNo():
				print 'Error reading ' + boxpath +': ' + bb.strError()
				sys.exit(10)

	else:
		print 'Error: ' + boxpath + ' is not readable!'
		sys.exit(10)

	dr = con.getDataRoot().getChildByIndex(0)

	config = NetworkList(dr)
	config_copy = NetworkList()
	config_copy.apply(config)
	print con.toXML()
	config.apply(config_copy)
	config_copy.unlink()
	print con.toXML()
	config.unlink()
	config_copy.apply(config)

